unit F_Convert;

interface

{$IFDEF FPC}
{$Mode Delphi}
{$R *.lfm}
{$ELSE}
{$R *.dfm}
{$ENDIF}

uses
{$IFDEF FPC}
  EditBtn,
{$ELSE}
  Mask, rxToolEdit,
{$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, FileCtrl,
  ExtCtrls, U_OnFormInfoIni, u_extdbgrid;

type

  { TForm1 }

  TForm1 = class(TForm)
    ch_utf8: TCheckBox;
    DirectoryEdit: TDirectoryEdit;
    FileListBoxLang2: TFileListBox;
    OnFormInfoIni: TOnFormInfoIni;
    Panel1: TPanel;
    FileListBox: TFileListBox;
    Convertir: TButton;
    FilterComboBox: TFilterComboBox;
    Messages: TMemo;
    Panel2: TPanel;
    SaveDialog: TSaveDialog;
    procedure ConvertirClick(Sender: TObject);
    procedure DirectoryEditChange(Sender: TObject);
    procedure FilterComboBoxChange(Sender: TObject);
  private
    procedure ConvertitField(var as_Ligne: String; const ai_LengthBegin: Integer
      );
    procedure ConvertitLigneDFMPAS(var as_Ligne: String);
    procedure ConvertitLigneLFM(const ast_Lignes: TStringList);
    procedure DeleteUntilEnd(const ast_Lignes: TStringList ; const ai_pos1, ai_posEnd : LongInt );
    procedure p_setLignes(const ast_lignes: TStringlist ;const FilePath : String);
    { Dclarations prives }
  public
    procedure ConvertitLignePAS( var ast_Lignes : TStringList; as_Lignes : String ); virtual;
    procedure ConvertitLigneDFM( var ast_Lignes : TStringList; as_Lignes : String ); virtual;
    procedure ConvertitFichier ( const FilePath, FileName, FilePath2, FileName2  : String );
    { Dclarations publiques }
  end;
var
  Form1: TForm1;

implementation

uses StrUtils, fonctions_file,LConvEncoding;

var gb_Posifndef_fpc : Boolean = False ;
    gb_report        : Boolean = False ;

procedure TForm1.ConvertirClick(Sender: TObject);
var ls_Directory : String;
begin
  Messages.Lines.Clear;
  ls_Directory := DirectoryEdit.{$IFDEF FPC}Directory{$ELSE}Text{$ENDIF};
  ConvertitFichier ( FileListBox.FileName, ExtractFileName ( FileListBox.FileName ), FileListBoxLang2.FileName, ExtractFileName ( FileListBoxLang2.FileName ));
  Messages.Lines.Add( '-> Tout est fini .' );
end;

procedure TForm1.DirectoryEditChange(Sender: TObject);
begin
  FileListBox.Directory := DirectoryEdit.{$IFDEF FPC}Directory{$ELSE}Text{$ENDIF} ;
  FileListBoxLang2.Directory := DirectoryEdit.{$IFDEF FPC}Directory{$ELSE}Text{$ENDIF} ;
end;

procedure TForm1.FilterComboBoxChange(Sender: TObject);
begin
  FileListBox.Mask := FilterComboBox.Mask;
end;


procedure TForm1.ConvertitField( var as_Ligne : String ; const ai_LengthBegin : Integer );
var li_i, li_2Maj : Integer ;
    lb_Maj, lb_Maj2 : Boolean ;
begin
  lb_Maj  := False ;
  lb_Maj2 := False ;
  li_2Maj := 0;
  for li_i := ai_LengthBegin to length ( as_Ligne ) do
    Begin
      if ( as_Ligne [ li_i ] = '.' ) Then
        Begin
          if lb_Maj2 Then
            as_Ligne := copy(as_Ligne, 1, li_2Maj-1) +
                        '.FieldByName(''' +
                        copy(as_Ligne, li_2Maj, li_i -li_2Maj) +
                        ''')' +
                        copy(as_Ligne, li_i, length ( as_Ligne ) - li_i +1) ;
          Exit;
        end;
      if ( as_Ligne [ li_i ] in ['A'..'Z','_'] ) Then
        Begin
          if lb_Maj Then
            Begin
              if not lb_Maj2 Then
                li_2Maj := li_i - 1;
              lb_Maj2 := True;
            end;
          lb_Maj := True;
        end
       Else
        if as_Ligne [ li_i ] <> ' ' Then
          Begin
            lb_Maj  := False ;
            lb_Maj2 := False ;
          end;
    end;
End;

procedure p_ReplaceButton ( var as_Ligne : String ; const as_replaceEnd : String );
Begin
  as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFW'+as_replaceEnd, [rfIgnoreCase] );
  as_Ligne := StringReplace ( as_Ligne, 'TFlatSpeedButton', 'TFS'+as_replaceEnd, [rfIgnoreCase] );
  as_Ligne := StringReplace ( as_Ligne, 'TFlatButton', 'TFB'+as_replaceEnd, [rfIgnoreCase] );
  as_Ligne := StringReplace ( as_Ligne, 'TBlueFlatSpeedButton', 'TBFS'+as_replaceEnd, [rfIgnoreCase] );
end;

procedure TForm1.ConvertitLigneDFMPAS( var as_Ligne : String );
begin

  if ( pos ( 'ferme', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'close', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Close');

  if ( pos ( 'btndel', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'supp', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'delete', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'MDelete');
 
  if ( pos ( 'btnadd', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'ajout' , lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'MAdd');

  if ( pos ( 'categ', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'MFolder');

  if ( pos ( 'quit', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Quit');

  if ( pos ( 'prec' , lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'prior', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Prior');
 
  if ( pos ( 'suiv' , lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'next', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Next');

  if ( pos ( 'import', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Import');

  if ( pos ( 'export', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Export');

  if ( pos ( 'copie', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Copy');

  if ( pos ( 'aperc', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'previo' , lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Preview');

  if ( pos ( 'enreg', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'select', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'appliq', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'ok' , lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'OK');

  if ( pos ( 'init', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Init');

  if ( pos ( 'config', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Config');

  if ( pos ( 'inser', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Insert');

  if ( pos ( 'annul', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'cancel', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Cancel');

  if ( pos ( 'imprim', lowercase ( as_Ligne ))> 0 )
  or ( pos ( 'print', lowercase ( as_Ligne ))> 0 ) then
    p_ReplaceButton ( as_Ligne, 'Print');
  as_Ligne := StringReplace( as_Ligne, 'DataBinding.FieldName', 'FieldName', [] );
  as_Ligne := StringReplace( as_Ligne, 'DataBinding.DataSource', 'DataSource', [] );
  as_Ligne := StringReplace( as_Ligne, 'Style.Color', 'Color', [] );

  as_Ligne := StringReplace( as_Ligne, 'Properties.FieldName', 'FieldName', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.KeyFieldNames', 'LookupField', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.DropDownRows', 'DropDownCount', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.ListSource', 'LookupSource', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.Grid.DataController.Values', 'KeyValue', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.ReadOnly', 'ReadOnly', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.OnChange', 'OnChange', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.OnFocus', 'OnFocus', [] );
  as_Ligne := StringReplace( as_Ligne, 'Properties.OnClick', 'OnClick', [] );
  if gb_report Then
    Begin
      as_Ligne := StringReplace( as_Ligne, 'UserName', 'FriendlyName', [rfReplaceAll,rfIgnoreCase] );
      as_Ligne := StringReplace( as_Ligne, 'Border.Color', 'Borders.Color', [rfReplaceAll,rfIgnoreCase] );
      as_Ligne := StringReplace( as_Ligne, 'Border.Style', 'Borders.Style', [rfReplaceAll,rfIgnoreCase] );
    end;
end;

procedure TForm1.p_setLignes ( const ast_lignes : TStringlist ;const FilePath : String );
var li_pos4, li_pos5 : LongInt ;
    ls_ligne : String ;
Begin
  ast_Lignes.Text := AnsiToUtf8 ( ast_Lignes.Text);
 { if pos ( '''#', ast_lignes.Text ) > 0 Then
    Begin
      ls_ligne:=ast_lignes.Text;
      li_pos4 := 1;
      while ( posex ( '''#', ls_Ligne, li_pos4 ) > 0 ) do
        Begin
          li_pos4 := posex ( '''#', ls_Ligne, li_pos4 );
          li_pos5 :=  posex ( '''', ls_Ligne, li_pos4 +1 );
          if li_pos5 - li_pos4 > 6 Then
            li_pos5 :=  posex ( '#', ls_Ligne, li_pos4 +1 );
          if  ( li_pos5 - li_pos4 < 7 )
          and ( li_pos5 - li_pos4 > 2 )
          and ( copy ( ls_Ligne, li_pos4 + 2, li_pos5 - li_pos4 - 2 ) [1] in ['0'..'9'] )
           Then
            try
  //            ShowMessage(copy ( ls_Ligne, li_pos4, li_pos5 - li_pos4 ) + ' : ' + copy ( ls_Ligne, li_pos4 + 2, li_pos5 - li_pos4 - 2));
              ls_Ligne := copy ( ls_Ligne, 1, li_pos4 - 1 )
                       + chr ( StrToInt( copy ( ls_Ligne, li_pos4 + 2, li_pos5 - li_pos4 - 2)))
                       + copy ( ls_Ligne, li_pos5 +1, Length( ls_Ligne ) - li_pos5 - 1 );

            Except
            end;
          inc ( li_pos4 );
        end;
      ast_Lignes.Text := ls_Ligne;
    end;   /}
  ConvertitLigneLFM ( ast_Lignes );
  ast_Lignes.SaveToFile   ( copy ( FilePath, 1, length ( filepath ) - 3 ) + 'lfm');

end;



procedure TForm1.ConvertitFichier(const FilePath, FileName, FilePath2, FileName2  : String);
var ls_entete1,ls_LignesId1, ls_Entete2,ls_LignesId2 : WideString ;
    lst_Lignes,
    lst_LignesResult,
    lst_Lignes2 : TStringList ;
    li_i, li_j, li_k, li_id, li_id1End, li_msg1, li_msg1End, li_msg2Begin, li_msg2End : Integer;
begin
  lst_Lignes := TStringList.Create;
  lst_Lignes2 := TStringList.Create;
  lst_LignesResult := TStringList.Create;
  try
    lst_Lignes.LoadFromFile ( FilePath );
    ls_entete1 := lst_Lignes.Text;

    lst_Lignes2.LoadFromFile ( FilePath2 );
    ls_LignesId1 := lst_Lignes2.Text;

    li_i := 0;
    li_j := 0;
    lst_LignesResult.BeginUpdate;
    while li_i < lst_Lignes.Count do
      Begin
        ls_entete1:=lst_Lignes [ li_i ];
        if pos ( '#: ', ls_entete1 ) = 1 Then
          Begin
            while li_j < lst_Lignes2.count do
              Begin
                ls_Entete2:=lst_Lignes2 [ li_j ];
                if pos ( '#: ', ls_entete2 ) = 1 Then
                  Break;
                inc ( li_j );
              end;
            if lowercase(ls_entete1) <> LowerCase(ls_Entete2) then
              Begin
                li_k := pos('.',ls_entete1);
                if  ( li_k > 2 )
                and ( PosEx('.',ls_entete1,li_k+1 ) > 0 ) Then
                  Begin
                    if copy ( LowerCase(ls_entete1), 1, li_k) + copy ( LowerCase(ls_entete1), PosEx('.',ls_entete1,li_k+1 ), Length(ls_entete1))
                    <> copy ( LowerCase(ls_entete2), 1, li_k) + copy ( LowerCase(ls_entete2), PosEx('.',ls_entete2,li_k+1 ), Length(ls_entete2)) Then
                      Begin
                        ShowMessage('Please update '+ copy ( ls_entete1, 1, li_k) + ' with correct name'
                                                    +' : '+#10 + FileName +', line ' +IntToStr(li_i+1)
                                                    +#10 + FileName2+', line ' +IntToStr(li_j+1));
                        Break;
                      End;

                  End
                Else
                 Begin
                  ShowMessage('Error at filenames : '+#10 + FileName +', line ' +IntToStr(li_i+1)
                                                     +#10 + FileName2+', line ' +IntToStr(li_j+1));
                  Break;
                 end;
              end;
            lst_LignesResult.Add(ls_entete1);
            while li_i < lst_Lignes.Count do
              Begin
                inc ( li_i );
                ls_LignesId1:=lst_Lignes [ li_i ];
                if (pos ( 'msgid' , ls_LignesId1 ) = 1 )
                or (pos ( 'msgstr', ls_LignesId1 ) = 1 ) Then
                  Begin
                    li_id:=li_i;
                    inc ( li_i );
                    while pos ( 'msgstr', lst_Lignes [ li_i ]) = 0 do
                      inc ( li_i );
                    for li_k := li_id to li_i -1 do
                      lst_LignesResult.Add(lst_Lignes [ li_k ]);

                    Break;
                  end;
              end;
            while li_j < lst_Lignes2.Count do
              Begin
                ls_LignesId2:=lst_Lignes2 [ li_j ];
                if (pos ( 'msgid' , ls_LignesId2 ) = 1 )
                or (pos ( 'msgstr', ls_LignesId2 ) = 1 ) Then
                  Begin
                    lst_LignesResult.Add(StringReplace(StringReplace(ls_LignesId2,'msgid','msgstr',[]),'\ ','\',[rfReplaceAll]));
                    li_id:=li_j;
                    inc ( li_j );
                    while pos ( 'msgstr', lst_Lignes2 [ li_j ]) = 0 do
                      inc ( li_j );
                    for li_k := li_id + 1 to li_j -1 do
                      lst_LignesResult.Add(StringReplace(lst_Lignes2 [ li_k ],'\ ','\',[rfReplaceAll]));
                    lst_LignesResult.Add('');
                    Break;
                  end;
                inc ( li_j );
              end;
            Application.ProcessMessages;
          end;
        inc ( li_i );
      end;
    lst_LignesResult.EndUpdate;
    SaveDialog.InitialDir:=ExtractFileDir(FilePath);
    if SaveDialog.Execute Then
     lst_LignesResult.SaveToFile   ( SaveDialog.FileName );

  finally
    lst_Lignes.Free;
    lst_LignesResult.Free;
    lst_Lignes2.Free;
    Messages.Lines.Add ( '  - Fichier ' + FileName + ' converti...' );
  end;

end;

function fb_IsField ( const as_ligne : String ) : Boolean;
Begin
  Result :=
       ( pos ( 'TIBStringField', as_Ligne )> 0 )
    or ( pos ( 'TIBBlobField', as_Ligne )> 0 )
    or ( pos ( 'TIBIntegerField', as_Ligne )> 0 )
    or ( pos ( 'TIBDateTimeField', as_Ligne )> 0 )
    or ( pos ( 'TIBFloatField', as_Ligne )> 0 )
    or ( pos ( 'TBlobField', as_Ligne )> 0 )
    or ( pos ( 'TFMTBCDField', as_Ligne )> 0 )
    or ( pos ( 'TDateTimeField', as_Ligne )> 0 )
    or ( pos ( 'TTimeField', as_Ligne )> 0 )
    or ( pos ( 'TDateField', as_Ligne )> 0 )
    or ( pos ( ':TIdHTTP', as_Ligne )> 0 )
    or ( pos ( ': TIdAntiFreeze', as_Ligne )> 0 )
    or ( pos ( ':TIdEncoderMIME', as_Ligne )> 0 )
    or ( pos ( 'TIntegerField', as_Ligne )> 0 )
    or ( pos ( 'TStringField', as_Ligne )> 0 )
    or ( pos ( 'TFloatField', as_Ligne )> 0 )
    or ( pos ( 'oemto', LowerCase( as_Ligne ) )> 0 )
    or ( pos ( 'tooem', LowerCase( as_Ligne ))> 0 )
    or ( pos ( 'TMemoField', as_Ligne )> 0 );
End;


function fb_posUnwanted ( const as_Begin, as_ligne : String ; const ab_Grid : Boolean ) : Boolean ;
Begin
  Result := ( pos ( as_Begin + 'TExtDBGridBandedTableViewStyleSheet', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtDBGridTableViewStyleSheet', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TDBCheckVirtualDBTreeExReportLink', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TDBCheckVirtualDBTreeExStyleSheet', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TdxCustomContainerReportLink', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TdxCustomContainerReportLink', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtraOptions', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TRLDetailGrid', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TcxIntlPrintSys3', as_Ligne )> 0 )
         or ( pos ( as_Begin + 'TcxIntlBars', as_Ligne )> 0 )
         or ( pos ( as_Begin + 'TcxIntl', as_Ligne )> 0 )
         or ( pos ( as_Begin + 'TDBCheckVirtualDBTreeExColumn', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtDBGridLevel', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TcxEditStyleController', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TWizardTree', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TcxHintStyleController', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TdxPrintStyleManager', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TBasedxPrintStyle', as_ligne )> 0 )
         or ( pos ( as_Begin + ' TppDBPipeline', as_ligne )> 0 )

         or ( pos ( as_Begin + 'TcxStyle', as_ligne )> 0 );
  if not Result
  and ab_Grid Then
  Result := ( pos ( as_Begin + 'TExtDBGridDBColumn', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtDBGridDBBandedTableView', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtDBGridDBTableView', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TColumnIndex', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtDBGridDBBandedColumn ', as_ligne )> 0 );

end;


procedure TForm1.ConvertitLignePAS( var ast_Lignes : TStringList; as_Lignes : String );
var li_pos1 : LongInt;
    ls_Ligne, ls_ligneLower : String;
    lb_delphi, lb_interface, lb_implementation, lb_uses1, lb_uses2, lb_usesend1, lb_usesend2 : Boolean ;

    procedure p_DeleteUnits ( const as_unitbegin : string );
    var li_pos2, li_pos3 : LongInt;
    Begin
      li_pos2:=1;
      while ( posex ( as_unitbegin, ls_ligneLower, li_pos2 ) > 0 ) do
        Begin
          li_pos2:= posex ( as_unitbegin, ls_ligneLower, li_pos2 );
          if ( li_pos2 = 1 )
          or ( ls_ligneLower [ li_pos2 - 1 ] in [' ', ','] )
           then
            Begin
              li_pos3:= PosEx( ',', ls_Ligne, li_pos2 );
              if li_pos3 = 0 then
                Begin
                  while ( li_pos2 > 0 ) and ( ls_ligneLower [ li_pos2 ] <> ',' ) do
                    dec ( li_pos2 );
                  if li_pos2 = 0 Then
                    ls_Ligne := '';
                  ls_Ligne:=copy ( ls_Ligne, 1, li_pos2 -1 );
                  ls_ligneLower:=copy ( ls_ligneLower, 1, li_pos2 - 1 );
                end
              else
                Begin
                  ls_Ligne:=copy ( ls_Ligne, 1, li_pos2 -1 ) + copy ( ls_ligne, li_pos3 + 1, length ( ls_ligneLower ) - li_pos3 );
                  ls_ligneLower:=copy ( ls_ligneLower, 1, li_pos2 - 1 ) + copy ( ls_ligneLower, li_pos3 + 1, length ( ls_ligneLower ) - li_pos3 );
                end;
            end
          else inc ( li_pos2 );
        end;
    End;
    function fb_DeleteCXDX ( var ab_uses : boolean ):Boolean;
    var li_pos2 : LongInt;
    Begin
      Result := False;
      if not ab_uses Then
        ab_uses:=     ( pos ( 'uses', ls_ligneLower ) > 0)
                  and ( pos ( 'uses', ls_ligneLower ) < 3);
      if ab_uses then
        Begin
          Result := pos ( ';', ls_ligne )>0;
          p_DeleteUnits ( 'cx' );
          p_DeleteUnits ( 'dx' );
          ast_Lignes.EndUpdate;
          while trim (ls_ligne) = '' do
            begin
              ast_Lignes.Delete(li_pos1);
              dec ( li_pos1 );
              ls_Ligne:= ast_Lignes [ li_pos1 ];
            end;
          ast_Lignes.BeginUpdate;
          if Result and (pos ( ';', ls_ligne )=0)
            then
             Begin
               ls_ligneLower:= LowerCase(ls_Ligne);
               li_pos2:=Length(ls_Ligne);
               while ( li_pos2 > 1 )
               and not ( ls_ligneLower [ li_pos2 ] in [ 'a'..'z' ]) do
                 Begin
                   if ls_ligne [ li_pos2 ] = ',' then
                    Begin
                     ls_ligne [ li_pos2 ] := ';';
                     Exit;
                    end;
                   dec ( li_pos2 );
                 end;
               AppendStr(ls_Ligne,';');
             end;
        end;
    end;

begin
  li_pos1 := -1;
  lb_delphi := False;
  lb_interface := False ;
  lb_implementation  := False ;
  lb_uses1  := False ;
  lb_uses2  := False ;
  lb_usesend1  := False ;
  lb_usesend2  := False ;
  ast_Lignes.BeginUpdate;
  while li_pos1 < ast_Lignes.Count - 1 do
    Begin
      inc ( li_pos1 );
      Application.ProcessMessages;
      ls_Ligne := ast_Lignes [ li_pos1 ];
      if not lb_implementation
      and fb_posUnwanted ( ':', ls_Ligne, True ) Then
       Begin
        ast_Lignes.EndUpdate;
        repeat
          ast_Lignes.Delete(li_pos1);
          ls_Ligne := ast_Lignes [ li_pos1 ];
        until not fb_posUnwanted ( ':', ls_Ligne, True );
        ast_Lignes.BeginUpdate;
       end;

      ls_ligneLower := LowerCase(ls_ligne);

      if  lb_interface
      and not lb_usesend1 Then
        lb_usesend1:= fb_DeleteCXDX(lb_uses1);

      if  lb_implementation
      and not lb_usesend2 Then
        lb_usesend2:= fb_DeleteCXDX(lb_uses2);

      if lb_implementation
      and not lb_usesend2 Then
        lb_usesend2 := pos ( 'begin', ls_ligneLower ) = 1;

      if lb_interface
      and not lb_usesend1 Then
        lb_usesend1 := ( pos ( 'type', ls_ligneLower ) = 1 ) or ( pos ( 'function', ls_ligneLower ) = 1 ) or ( pos ( 'procedure', ls_ligneLower ) = 1 );


      if not lb_interface Then
       lb_interface := ( pos ( 'interface', ls_ligneLower ) = 1 ) or ( pos ( 'type', ls_ligneLower ) = 1 ) or ( pos ( 'function', ls_ligneLower ) = 1 ) or ( pos ( 'procedure', ls_ligneLower ) = 1 );

      if not lb_implementation Then
        lb_implementation := ( pos ( 'implementation', ls_ligneLower ) = 1 ) or ( pos ( 'begin', ls_ligneLower ) = 1 );
      if not lb_implementation
      and fb_IsField ( ls_ligne )
      and (( pos ( 'procedure', ls_Ligne )= 0 ) and ( pos ( 'function', ls_Ligne )= 0 ))
       Then
       Begin
         if not lb_delphi
         and not gb_Posifndef_fpc Then
           Begin
             ast_Lignes.Insert(li_pos1, '{$IFNDEF FPC}');
             inc(li_pos1);
             lb_delphi := True;
           end;
       end
      else
      Begin
        if lb_delphi Then
          Begin
            ast_Lignes.Insert(li_pos1, '{$ENDIF}');
            inc(li_pos1);
            lb_delphi := False;
          end;
      end;

      if ( pos ( 'query', LowerCase( ls_Ligne ) )> 0 ) Then
       Begin
         ConvertitField( ls_Ligne, pos ( 'query', LowerCase( ls_Ligne )) + 5 );
       end;
      if ( pos ( 'ibq', LowerCase( ls_Ligne ))> 0 ) Then
       Begin
         ConvertitField( ls_Ligne, pos ( 'ibq', LowerCase( ls_Ligne )) + 3 );
       end
      else if ( pos ( 'IB', ls_Ligne )> 0 ) Then
       Begin
         ConvertitField( ls_Ligne, pos ( 'IB', ls_Ligne ) + 2 );
       end;
      ConvertitLigneDFMPAS ( ls_ligne );
      ast_Lignes [ li_pos1 ] := ls_Ligne;

    End;
end;

procedure TForm1.ConvertitLigneDFM( var ast_Lignes : TStringList; as_Lignes : String );
var li_pos1, li_pos2, li_pos3, li_pos4, li_pos5, li_pos6 : LongInt;
    ls_Ligne, ls_temp : String;
    lb_columns, lb_lookup, lb_end, lb_tree, lb_grid, lb_double : Boolean;

function fb_IsGridColumn ( const as_ligne : String ) : Boolean ;
begin
  Result := ( pos ( 'TExtDBGridDBColumn', as_Ligne  ) > 0 )
            or ( pos ( 'TDBCheckVirtualDBTreeExColumn', as_Ligne  ) > 0 )
            or ( pos ( 'TColumnIndex', as_Ligne  ) > 0 )
            or ( pos ( 'TExtDBGridDBBandedColumn', as_Ligne ) > 0 );
end;

function fb_deleteOtherItem : Boolean;
begin
  if ( pos ( '<', ls_ligne ) > 0 ) Then
   Begin
    repeat
     ls_ligne := ast_Lignes [ li_pos1 ];
     ast_Lignes.delete ( li_pos1 );
    until pos ( '>', ls_ligne ) > 0;
    Result := True;
    dec ( li_pos1 );
    Exit;
   end;
  Result := False;

end;

begin
  li_pos1 := -1;
  li_pos2 := -1;
  li_pos3 := -1;
  li_pos4 := -1;
  lb_columns := False;
  lb_lookup  := False;
  lb_end := True;
  lb_tree := False ;
  lb_double := False ;
  lb_grid:=False;
  ast_Lignes.BeginUpdate;
  while li_pos1 < ast_Lignes.Count - 1 do
    Begin
      inc ( li_pos1 );
      Application.ProcessMessages;
      ls_Ligne := ast_Lignes [ li_pos1 ];
      if fb_posUnwanted ( '', ls_Ligne, False )
       Then
        Begin
          ast_Lignes.EndUpdate;
          DeleteUntilEnd(ast_Lignes,li_pos1, pos ( 'object', ls_Ligne ));
          ast_Lignes.BeginUpdate;
          dec ( li_pos1 );
          Continue;
        end;
      if not lb_lookup
      and not lb_grid
      and not lb_tree then
        Begin
          lb_grid := pos ( 'TExtDBGrid', ls_Ligne ) > 0;
          li_pos2 := pos ( 'object', ls_Ligne );
          lb_tree := False ;
          lb_double := False ;
          if  not lb_grid then
            Begin
              lb_tree := pos ( 'TDBCheckVirtualDBTreeEx', ls_Ligne ) > 0;
              li_pos2 := pos ( 'object', ls_Ligne );
              lb_grid:=False;
              lb_double := False ;
            End;
        End;
      if not lb_columns
      and ( lb_grid or lb_tree ) Then
        Begin
          li_pos4 := pos ( 'TExtDBGridDBTableView', ls_Ligne );
          if li_pos4 = 0 Then
            li_pos4 := pos ( 'TColumnIndex', ls_Ligne );
          if li_pos4 = 0 Then
            li_pos4 := pos ( 'TExtDBGridDBBandedTableView', ls_Ligne  ) ;

          if li_pos4 > 0 then
           begin
            lb_double := True ;
            li_pos2 := pos ( 'object', ls_Ligne );
            ast_Lignes.Delete(li_pos1);
            dec ( li_pos1 );
            while not fb_IsGridColumn ( ls_Ligne ) do
                begin
                  inc ( li_pos1 );
                  ls_Ligne:=ast_Lignes [ li_pos1 ];
                  if fb_deleteOtherItem Then
                    Continue;
                  if ( pos ( 'end', ls_Ligne ) > 0 ) Then
                   Begin
                    ast_Lignes.Delete(li_pos1);
                    dec ( li_pos1 );
                    Break;
                   end;
                end;
            ls_Ligne:=ast_Lignes [ li_pos1 ];
           end;
          if ( lb_double )
          and ( pos ( 'end', ls_Ligne ) = li_pos2 ) Then
            Begin
              li_pos3 := li_pos2 - 2 ;
              if lb_tree Then
                begin
                  ast_Lignes [ li_pos1 ] := '              Header.Columns = <';
                end
              Else
                ast_Lignes [ li_pos1 ] := '              Columns = <';
              lb_tree:=True;
              lb_columns := True;
              lb_end := True;
              inc(li_pos1);
              ast_Lignes.Insert(li_pos1,'              item');
            End
         else if (  fb_IsGridColumn (ls_Ligne ) ) Then
           Begin
              li_pos3 := pos ( 'object', ls_Ligne  );
              if lb_tree Then
                ast_Lignes [ li_pos1 ] := '              Header.Columns = <'
              Else
                ast_Lignes [ li_pos1 ] := '              Columns = <';
              lb_tree:=False;
              lb_columns := True;
              lb_end := True;
              inc(li_pos1);
              ast_Lignes.Insert(li_pos1,'              item');
              li_pos2:=li_pos3;
            end;
         if ( not lb_double )
         and ( pos ( 'end', ls_Ligne ) = li_pos2 ) Then
           begin
            lb_tree:=False;
            lb_grid:=False;
           end;
         Continue;
        End;

      if lb_columns then
        begin
          if ( pos ( 'Properties.', ls_Ligne ) > 0 )
          or ( pos ( 'Options.', ls_Ligne ) > 0 )
          or ( pos ( 'Styles.', ls_Ligne ) > 0 )
          or ( pos ( 'Position.', ls_Ligne ) > 0 )
          or ( pos ( 'Styles.', ls_Ligne ) > 0 )
          or ( pos ( 'PropertiesClassName', ls_Ligne ) > 0 )
           Then
            Begin
             ast_Lignes.Delete(li_pos1);
             dec (li_pos1 );
             Continue;
            end;
          if fb_deleteOtherItem Then
            Continue;
          li_pos4 := pos ( 'end', ls_Ligne );
          if fb_IsGridColumn ( ls_ligne )
           Then
            Begin
              if pos ( 'item', ast_Lignes [ li_pos1 - 1 ]) > 0 Then
                Begin
                  ast_Lignes.Delete ( li_pos1 );
                  dec ( li_pos1 );
                  Continue;
                end;
              ast_Lignes [ li_pos1 ] := '              item';
              ast_Lignes.Insert ( li_pos1, '              end');
              inc ( li_pos1 );
              Continue;
            End;
          if  ( li_pos4 > 0 ) Then
           Begin
             if  lb_double
             and ( li_pos4 = li_pos2 )
              then
               Begin
                 if ( pos ( 'end', ast_Lignes [ li_pos1 + 1 ] ) > 0 ) then
                   if lb_tree Then
                     Continue
                    Else
                     ast_Lignes [ li_pos1 + 1 ] := StringReplace ( ast_Lignes [ li_pos1 + 1 ], 'end', 'end>', [] );
                 ast_Lignes.EndUpdate;
                 ast_Lignes.delete ( li_pos1 );
                 ast_Lignes.BeginUpdate;
                 lb_end := False;
                 dec ( li_pos1, 2 );
                 Continue;
               End;
             if  ( li_pos4 < li_pos2 ) then
               Begin
                 if ( lb_tree )
                 and ( pos ( 'end', ast_Lignes [ li_pos1 - 1 ] ) > 0 )
                  then
                   Begin
                     ast_Lignes [ li_pos1 - 1 ] := StringReplace ( ast_Lignes [ li_pos1 - 1 ], 'end', 'end>', [] );
                   End;
                 lb_columns := False;
                 lb_tree    := False;
                 lb_grid    := False;
                 Continue;
               End;
            if ( li_pos4 = li_pos3 ) Then

             begin
              if pos ( 'TExtDBGridDBBandedTableView', ast_Lignes [ li_pos1 + 2 ] ) > 0 Then
                repeat
                  ast_Lignes.delete ( li_pos1 + 1 ) ;
                until (    fb_IsGridColumn ( ast_Lignes [ li_pos1 + 1 ] )
                      or (     ( pos ( ' end', ast_Lignes [ li_pos1 + 1 ] ) > 0 )
                           and ( pos ( 'end', ast_Lignes [ li_pos1 + 1 ] ) <= li_pos3 )));
              if not fb_IsGridColumn ( ast_Lignes [ li_pos1 + 1 ] )
               then
                Begin
                  ast_Lignes [ li_pos1 ] := StringReplace ( ls_Ligne, 'end', 'end>', [] );
                  Continue;
                End;

             end;
           end;
          if pos ( 'FieldName', ls_Ligne )> 0 then
            ls_Ligne := StringReplace( ls_Ligne, 'DataBinding.', '', [] )
          else if pos ( 'Caption', ls_Ligne )> 0 then
            ls_Ligne := StringReplace( ls_Ligne, 'Caption', 'Title.Caption', [] )
          else if pos ( 'Width', ls_Ligne )= 0 then
            Continue;
        end;
      if not lb_lookup
      and not lb_columns Then
        Begin
          li_pos2 := pos ( 'Properties.ListColumns', ast_Lignes [ li_pos1 ] );
          if li_pos2 <> 0 then
            Begin
              inc ( li_pos2, 2 );
              ls_Ligne := '  LookupDisplay = ''';
              while ( pos ( 'end>', ast_Lignes [ li_pos1 ] ) <> li_pos2 ) do
                Begin
                  if pos ( 'FieldName', ast_Lignes [ li_pos1 ] ) <> 0 Then
                    ls_Ligne := ls_Ligne + Copy ( ast_Lignes [ li_pos1 ], pos ( '''', ast_Lignes [ li_pos1 ]) + 1 , posex ( '''', ast_Lignes [ li_pos1 ], pos ( '''', ast_Lignes [ li_pos1 ]) + 1) - li_pos1 - 1 )  + ',';
                  ast_Lignes.Delete(li_pos1);
                End;
              ls_Ligne [ Length(ls_Ligne)] := '''';
              ast_Lignes [ li_pos1 ] := ls_Ligne;
              Continue;
            End;

        End;
       if ( pos ( 'Items', ls_Ligne )> 0 )
       and ( pos ( '>', ls_Ligne )> 0 )
       Then
       Begin
         ast_Lignes.EndUpdate;
         repeat
           ls_Ligne := ast_Lignes [ li_pos1 ];
           ast_Lignes.Delete(li_pos1);
         until pos ( 'end>', ls_Ligne ) > 0;
         dec ( li_pos1 );
         ast_Lignes.BeginUpdate;
         Continue;
       end;
       if ( pos ( 'PreviewOptions.PreviewBoundsRect', ls_Ligne )> 0 )
       or ( pos ( 'PreviewOptions.WindowState', ls_Ligne )> 0 )
       Then
       Begin
         ast_Lignes.EndUpdate;
         ast_Lignes.Delete(li_pos1);
         dec ( li_pos1 );
         ast_Lignes.BeginUpdate;
         Continue;
       end;
       if ( pos ( 'mmHeight', ls_ligne ) > 0 )
       or ( pos ( 'mmTop'   , ls_ligne ) > 0 )
       or ( pos ( 'mmWidth' , ls_ligne ) > 0 )
       or ( pos ( 'mmLeft'  , ls_ligne ) > 0 ) Then
         begin
           ls_Ligne := StringReplace( ls_Ligne, 'mm', '', [rfIgnoreCase] );
           ls_temp := copy ( ls_Ligne, pos ( '= ', ls_ligne ) + 2, length ( ls_ligne ) - pos ( '= ', ls_ligne ) - 1 );
           if length ( ls_temp ) > 3 Then
             ls_Ligne := copy ( ls_Ligne, 1, length ( ls_ligne ) - 3 )
           else if length ( ls_temp ) > 2 Then
             ls_Ligne := copy ( ls_Ligne, 1, length ( ls_ligne ) - 2 )
           else if length ( ls_temp ) > 1 Then
             ls_Ligne := copy ( ls_Ligne, 1, length ( ls_ligne ) - 1 );
         end;
      if pos ( 'DataPipeline', ls_ligne ) > 0 Then
        begin
          ls_temp := copy ( ls_Ligne, pos ( '= ', ls_ligne ) + 2, length ( ls_ligne ) - pos ( '= ', ls_ligne ) - 1 ) + ':';
          for li_pos5 := ast_Lignes.count -1 downto 0 do
            if  ( pos ( ls_temp, ast_Lignes [ li_pos5 ])>0 )
            and ( pos ( 'object', ast_Lignes [ li_pos5 ])>0 ) Then
              begin
                for li_pos6  := li_pos5 + 1 to ast_Lignes.count -1 do
                  if ( pos ( 'DataSource', ast_Lignes [ li_pos6 ] ) > 0 ) Then
                    Begin
                      ast_Lignes [ li_pos1 ] := ast_Lignes [ li_pos6 ];
                      Break;
                    end;
                Break;
              end;
          Continue;
        end;
      ConvertitLigneDFMPAS ( ls_ligne );
      ast_Lignes [ li_pos1 ] := ls_Ligne;

    End;
end;

procedure TForm1.DeleteUntilEnd( const ast_Lignes : TStringList ; const ai_pos1, ai_posEnd : LongInt );
var ls_Ligne : String;
Begin
  repeat
  ls_Ligne := ast_Lignes [ ai_pos1 ];
  ast_Lignes.Delete( ai_pos1);
  until ( pos ( 'end', ls_Ligne ) > 0 )
    and (( ai_posEnd = -1 ) or ( ai_posEnd = pos ( 'end', ls_Ligne )));
end;

procedure TForm1.ConvertitLigneLFM( const ast_Lignes : TStringList );
var li_pos1 : LongInt;
    ls_Ligne : String;

begin
  li_pos1 := -1;
  while li_pos1 < ast_Lignes.Count - 1 do
    Begin
      inc ( li_pos1 );
      Application.ProcessMessages;
      ls_Ligne := ast_Lignes [ li_pos1 ];
      if fb_IsField ( ls_Ligne )
       Then
       Begin
         DeleteUntilEnd(ast_Lignes, li_pos1, pos ( 'object', ls_Ligne ));
         dec ( li_pos1 );
         Continue;
       end;

    End;
end;

end.
