unit F_Convert;

interface

{$IFDEF FPC}
{$Mode Delphi}
{$R *.lfm}
{$ELSE}
{$R *.dfm}
{$ENDIF}

uses
{$IFDEF FPC}
  EditBtn,
{$ELSE}
  Mask, rxToolEdit,
{$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, FileCtrl,
  ExtCtrls, U_OnFormInfoIni;

type

  { TForm1 }

  TForm1 = class(TForm)
    ch_utf8: TCheckBox;
    DirectoryEdit: TDirectoryEdit;
    OnFormInfoIni: TOnFormInfoIni;
    Panel1: TPanel;
    FileListBox: TFileListBox;
    Convertir: TButton;
    FilterComboBox: TFilterComboBox;
    Messages: TMemo;
    Panel2: TPanel;
    procedure ConvertirClick(Sender: TObject);
    procedure DirectoryEditChange(Sender: TObject);
    procedure FilterComboBoxChange(Sender: TObject);
  private
    procedure ConvertirDir(const as_Directory: String);
    procedure ConvertitField(var as_Ligne: String; const ai_LengthBegin: Integer
      );
    procedure DeleteUntilEnd(const ast_Lignes: TStringList ; const ai_pos1, ai_posEnd : LongInt );
    { Dclarations prives }
  public
    procedure ConvertitLigneText( var ast_Lignes : TStringList; as_Lignes : String ); virtual;
    procedure ConvertitFichier ( const FilePath, FileName  : String );
    { Dclarations publiques }
  end;
var
  Form1: TForm1;

implementation

uses StrUtils, FileUtil, fonctions_file,LConvEncoding, LazFileUtils;

var gb_Posifndef_fpc : Boolean = False ;
    gb_report        : Boolean = False ;

procedure TForm1.ConvertirClick(Sender: TObject);
var ls_Directory : String;
begin
  Messages.Lines.Clear;
  ls_Directory := DirectoryEdit.{$IFDEF FPC}Directory{$ELSE}Text{$ENDIF};
  ConvertirDir ( DirectoryEdit.{$IFDEF FPC}Directory{$ELSE}Text{$ENDIF} );
  Messages.Lines.Add( '-> Tout est fini .' );
end;

procedure TForm1.DirectoryEditChange(Sender: TObject);
begin
  FileListBox.Directory := DirectoryEdit.{$IFDEF FPC}Directory{$ELSE}Text{$ENDIF} ;
end;

procedure TForm1.FilterComboBoxChange(Sender: TObject);
begin
  FileListBox.Mask := FilterComboBox.Mask;
end;

procedure TForm1.ConvertirDir(const as_Directory : String );
var lstl_StringList : TStringList;
begin
  lstl_StringList := TStringList.Create;
  Messages.Lines.Add( '-> Parcours de ' + as_Directory );
  if fb_FindFiles ( lstl_StringList, as_Directory, True, True, True ) Then
    Begin
      while lstl_StringList.Count > 0 do
       Begin
        if (DirectoryexistsUTF8 ( lstl_StringList [ 0 ] )) then
          Begin
            ConvertirDir(lstl_StringList [ 0 ] );
          End
         else
           if (FileexistsUTF8 ( lstl_StringList [ 0 ] )) then
              ConvertitFichier ( lstl_StringList [ 0 ], ExtractFileName ( lstl_StringList [ 0 ] ));
         lstl_StringList.Delete ( 0 );
       end;

    End;
  Messages.Lines.Add( '-> Fin pour ' + as_Directory + '.' );
  lstl_StringList.free;
end;

procedure TForm1.ConvertitField( var as_Ligne : String ; const ai_LengthBegin : Integer );
var li_i, li_2Maj : Integer ;
    lb_Maj, lb_Maj2 : Boolean ;
begin
  lb_Maj  := False ;
  lb_Maj2 := False ;
  li_2Maj := 0;
  for li_i := ai_LengthBegin to length ( as_Ligne ) do
    Begin
      if ( as_Ligne [ li_i ] = '.' ) Then
        Begin
          if lb_Maj2 Then
            as_Ligne := copy(as_Ligne, 1, li_2Maj-1) +
                        '.FieldByName(''' +
                        copy(as_Ligne, li_2Maj, li_i -li_2Maj) +
                        ''')' +
                        copy(as_Ligne, li_i, length ( as_Ligne ) - li_i +1) ;
          Exit;
        end;
      if ( as_Ligne [ li_i ] in ['A'..'Z','_'] ) Then
        Begin
          if lb_Maj Then
            Begin
              if not lb_Maj2 Then
                li_2Maj := li_i - 1;
              lb_Maj2 := True;
            end;
          lb_Maj := True;
        end
       Else
        if as_Ligne [ li_i ] <> ' ' Then
          Begin
            lb_Maj  := False ;
            lb_Maj2 := False ;
          end;
    end;
End;

procedure p_ReplaceButton ( var as_Ligne : String ; const as_replaceEnd : String );
Begin
  as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFW'+as_replaceEnd, [rfIgnoreCase] );
  as_Ligne := StringReplace ( as_Ligne, 'TFlatSpeedButton', 'TFS'+as_replaceEnd, [rfIgnoreCase] );
  as_Ligne := StringReplace ( as_Ligne, 'TFlatButton', 'TFB'+as_replaceEnd, [rfIgnoreCase] );
  as_Ligne := StringReplace ( as_Ligne, 'TBlueFlatSpeedButton', 'TBFS'+as_replaceEnd, [rfIgnoreCase] );
end;




procedure TForm1.ConvertitFichier(const FilePath, FileName : String);
var ls_Lignes : WideString ;
    lb_txt : Boolean ;
    lst_Lignes : TStringList ;
begin
  lb_txt := PosEx ( '.txt', LowerCase ( FileName ), length ( FileName ) - 5 ) > 0 ;
  lst_Lignes := TStringList.Create;
  if ( lb_txt ) then
    try
     {if ch_utf8.Checked Then
       Begin
         lst_Lignes.LoadFromFile ( FilePath );
         lst_Lignes.text := ISO_8859_1ToUTF8(lst_Lignes.Text);
         lst_Lignes.SaveToFile   ( FilePath );
       end;                                }
      lst_Lignes.LoadFromFile ( FilePath );

      ConvertitLigneText ( lst_Lignes, FilePath );
      Application.ProcessMessages;
  finally
   // lst_Lignes.EndUpdate;
      //  if ch_utf8.Checked Then
         // lst_Lignes.Text := AnsiToUtf8 ( lst_Lignes.Text);
    lst_Lignes.SaveToFile   ( FilePath );

    lst_Lignes.Free;
    Messages.Lines.Add ( '  - Fichier ' + FileName + ' converti...' );
  end;

end;

function fb_IsField ( const as_ligne : String ) : Boolean;
Begin
  Result :=
       ( pos ( 'TIBStringField', as_Ligne )> 0 )
    or ( pos ( 'TIBBlobField', as_Ligne )> 0 )
    or ( pos ( 'TIBIntegerField', as_Ligne )> 0 )
    or ( pos ( 'TIBDateTimeField', as_Ligne )> 0 )
    or ( pos ( 'TIBFloatField', as_Ligne )> 0 )
    or ( pos ( 'TBlobField', as_Ligne )> 0 )
    or ( pos ( 'TFMTBCDField', as_Ligne )> 0 )
    or ( pos ( 'TDateTimeField', as_Ligne )> 0 )
    or ( pos ( 'TTimeField', as_Ligne )> 0 )
    or ( pos ( 'TDateField', as_Ligne )> 0 )
    or ( pos ( ':TIdHTTP', as_Ligne )> 0 )
    or ( pos ( ': TIdAntiFreeze', as_Ligne )> 0 )
    or ( pos ( ':TIdEncoderMIME', as_Ligne )> 0 )
    or ( pos ( 'TIntegerField', as_Ligne )> 0 )
    or ( pos ( 'TStringField', as_Ligne )> 0 )
    or ( pos ( 'TFloatField', as_Ligne )> 0 )
    or ( pos ( 'TMemoField', as_Ligne )> 0 );
End;


function fb_posUnwanted ( const as_Begin, as_ligne : String ; const ab_Grid : Boolean ) : Boolean ;
Begin
  Result := ( pos ( as_Begin + 'TExtDBGridBandedTableViewStyleSheet', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtDBGridTableViewStyleSheet', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TDBCheckVirtualDBTreeExReportLink', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TDBCheckVirtualDBTreeExStyleSheet', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TdxCustomContainerReportLink', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TdxCustomContainerReportLink', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtraOptions', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TRLDetailGrid', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TcxIntlPrintSys3', as_Ligne )> 0 )
         or ( pos ( as_Begin + 'TcxIntlBars', as_Ligne )> 0 )
         or ( pos ( as_Begin + 'TcxIntl', as_Ligne )> 0 )
         or ( pos ( as_Begin + 'TDBCheckVirtualDBTreeExColumn', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtDBGridLevel', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TcxEditStyleController', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TWizardTree', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TcxHintStyleController', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TdxPrintStyleManager', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TBasedxPrintStyle', as_ligne )> 0 )

         or ( pos ( as_Begin + 'TcxStyle', as_ligne )> 0 );
  if not Result
  and ab_Grid Then
  Result := ( pos ( as_Begin + 'TExtDBGridDBColumn', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtDBGridDBBandedTableView', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtDBGridDBTableView', as_ligne )> 0 )
         or ( pos ( as_Begin + 'TExtDBGridDBBandedColumn ', as_ligne )> 0 );

end;


procedure TForm1.ConvertitLigneText( var ast_Lignes : TStringList; as_Lignes : String );
var li_pos1, li_pos2 : LongInt;
    ls_Ligne : String;

begin
  li_pos1 := -1;
  ast_Lignes.BeginUpdate;
  while li_pos1 < ast_Lignes.Count - 1 do
    Begin
      inc ( li_pos1 );
      Application.ProcessMessages;
      ls_Ligne := ast_Lignes [ li_pos1 ];
      li_pos2 := pos ( '{{anchor|', ls_Ligne );
      if li_pos2 > 0 then
        Begin
          ls_Ligne:= copy ( ls_Ligne, 1, li_pos2 - 1 )+Copy(ls_Ligne,PosEx('}}',ls_Ligne,li_pos2)+2,Length(ls_Ligne));
          ast_Lignes [ li_pos1 ] := ls_Ligne;

        end;

    End;
end;

procedure TForm1.DeleteUntilEnd( const ast_Lignes : TStringList ; const ai_pos1, ai_posEnd : LongInt );
var ls_Ligne : String;
Begin
  repeat
  ls_Ligne := ast_Lignes [ ai_pos1 ];
  ast_Lignes.Delete( ai_pos1);
  until ( pos ( 'end', ls_Ligne ) > 0 )
    and (( ai_posEnd = -1 ) or ( ai_posEnd = pos ( 'end', ls_Ligne )));
end;

end.
