unit F_Convertir;

{$IFDEF FPC}
{$MODE Delphi}
{$R *.lfm}
{$ENDIF}

interface

uses
  SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, ExtCtrls, LResources, EditBtn, U_OnFormInfoIni;

type

  { TForm1 }

  TForm1 = class(TForm)
    ch_utf8: TCheckBox;
    DirectoryEdit: TDirectoryEdit;
    DirectoryListBox: TDirectoryEdit;
    OnFormInfoIni: TOnFormInfoIni;
    Panel1: TPanel;
    FileListBox: TFileListBox;
    Convertir: TButton;
    FilterComboBox: TFilterComboBox;
    Messages: TMemo;
    Panel2: TPanel;
    procedure ConvertirClick(Sender: TObject);
    procedure DirectoryEdit1Change(Sender: TObject);
    procedure DirectoryEditChange(Sender: TObject);
    procedure FilterComboBoxChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OnFormInfoIniFormShow(Sender: TObject);
  private
    procedure ConvertitLigneDFMPAS(var as_Ligne: WideString);
    procedure ConvertitPanelDFM(var asl_Lignes: TStringList;
      const ai_PosLigne: Longint; const as_Ligne, as_ReplaceString: String);
    { Dclarations prives }
  public
    procedure ConvertitLignePAS( var ast_Lignes : TStringList; as_Lignes : WideString ); virtual;
    procedure ConvertitLigneDFM( var asl_Lignes : TStringList; as_Lignes : WideString ); virtual;
    procedure ConvertitColumn( var asl_Lignes: TStringList; const as_Ligne : WideString; var li_pos1,li_pos2, li_endcol : Longint ; const li_noData : Longint );
    procedure ConvertitFichier ( const FilePath, FileName  : String );
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation


uses StrUtils,LConvEncoding;

procedure TForm1.ConvertirClick(Sender: TObject);
var li_i : Integer ;
begin
  Messages.Lines.Clear;
  Messages.Lines.Add( '-> Parcourt de ' + DirectoryEdit.Directory );
  For Li_i := 0 To FileListBox.Items.Count - 1 do
    Begin
      ConvertitFichier ( DirectoryEdit.Directory + DirectorySeparator + FileListBox.Items.Strings [ li_i ], FileListBox.Items.Strings [ li_i ] );
    End ;
  Messages.Lines.Add ( '-> Fin pour ' + DirectoryEdit.Directory + '.' );
end;

procedure TForm1.DirectoryEdit1Change(Sender: TObject);
begin

end;

procedure TForm1.DirectoryEditChange(Sender: TObject);
begin
  FileListBox.Directory := DirectoryEdit.Directory ;
end;

procedure TForm1.FilterComboBoxChange(Sender: TObject);
begin
  FileListBox.Mask := FilterComboBox.Mask;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if DirectoryEdit.Directory = '' Then
    DirectoryEdit.Directory:= GetCurrentDir;
end;

procedure TForm1.OnFormInfoIniFormShow(Sender: TObject);
begin
 FilterComboBoxChange ( Self );
end;

procedure TForm1.ConvertitFichier(const FilePath, FileName : String);
var ls_Lignes : WideString ;
    lb_DFM ,
    lb_LFM : Boolean ;
    lst_Lignes : TStringList ;

    afile : TextFile ;

begin
  lb_DFM := PosEx ( '.dfm', LowerCase ( FilePath ), length ( FilePath ) - 5 ) >= length ( FilePath ) - 5 ;
  lb_LFM := PosEx ( '.lfm', LowerCase ( FilePath ), length ( FilePath ) - 5 ) >= length ( FilePath ) - 5 ;
  lst_Lignes := TStringList.Create;
  try
    lst_Lignes.BeginUpdate;
     if ch_utf8.Checked Then
       Begin
         lst_Lignes.LoadFromFile ( FilePath );
         lst_Lignes.text := ISO_8859_1ToUTF8(lst_Lignes.Text);
         lst_Lignes.SaveToFile   ( FilePath );
       end;
    lst_Lignes.LoadFromFile ( FilePath );
    ls_Lignes := lst_Lignes.Text;

    Application.ProcessMessages;


    // Conversion Extended
(*
    ls_Lignes := StringReplace ( ls_Lignes, '{$IFDEF FPC}{$IFDEF FPC}{$IFDEF FPC}{$IFDEF FPC}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ELSE}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ENDIF}{$ELSE}{$IFDEF FPC}'+
                                            '{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ELSE}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ENDIF}{$ENDIF}{$ELSE}{$IFDEF FPC}{$IFDEF FPC}{$IFDEF FPC}LCLType,{$ELSE}Windows,'+
                                            '{$ENDIF}{$ELSE}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ENDIF}{$ELSE}{$IFDEF FPC}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ELSE}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}'+
                                            '{$ENDIF}{$ENDIF}{$ENDIF}{$ELSE}{$IFDEF FPC}{$IFDEF FPC}{$IFDEF FPC}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ELSE}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ENDIF}{$ELSE}{$IFDEF FPC}'+
                                            '{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ELSE}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ENDIF}{$ENDIF}{$ELSE}{$IFDEF FPC}{$IFDEF FPC}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ELSE}'+
                                            '{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ENDIF}{$ELSE}{$IFDEF FPC}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ELSE}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ENDIF}{$ENDIF}{$ENDIF}{$ENDIF}', '{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, '{$IFDEF FPC}{$IFDEF FPC}{$IFDEF FPC}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ELSE}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ENDIF}{$ELSE}{$IFDEF FPC}'+
                                            '{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ELSE}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ENDIF}{$ENDIF}{$ELSE}{$IFDEF FPC}{$IFDEF FPC}{$IFDEF FPC}LCLType,{$ELSE}Windows,'+
                                            '{$ENDIF}{$ELSE}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ENDIF}{$ELSE}{$IFDEF FPC}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ELSE}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}'+
                                            '{$ENDIF}{$ENDIF}{$ENDIF}{$ELSE}{$IFDEF FPC}{$IFDEF FPC}{$IFDEF FPC}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ELSE}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ENDIF}{$ELSE}{$IFDEF FPC}'+
                                            '{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ELSE}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ENDIF}{$ENDIF}{$ELSE}{$IFDEF FPC}{$IFDEF FPC}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ELSE}'+
                                            '{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ENDIF}{$ELSE}{$IFDEF FPC}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ELSE}{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}{$ENDIF}{$ENDIF}{$ENDIF}{$ENDIF}', '{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}', [rfReplaceAll,rfIgnoreCase] );
*)
    ls_Lignes := StringReplace ( ls_Lignes, 'TADOTable', 'TZQuery', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'p_ExecuteFonction', 'ffor_ExecuteFonction', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TADOQuery', 'TZQuery', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'adot_', 'zq_', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'dxButton', 'JvXPButton', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TJvXpButtons', 'TJvXPButton', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'Windows,', 'LCLType,', [rfReplaceAll,rfIgnoreCase] );
    if pos ( '{$IFDEF FPC}', ls_Lignes ) = 0 Then
      Begin
       ls_Lignes := StringReplace ( ls_Lignes, 'Windows,', '{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}', [rfReplaceAll,rfIgnoreCase] );
      end;

    ls_Lignes := StringReplace ( ls_Lignes, '{$IFDEF FPC}LCLTypeWindows,,', '{$IFDEF FPC}LCLType,{$ELSE}Windows,{$ENDIF}', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'adoq_', 'zq_', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TRxDBLookupCombo', 'TFWDBLookupCombo', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TJvDBMaskEdit', 'TFWDBEdit', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TJvEdit', 'TFWEdit', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'ADODB', 'ZDataset', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TJvDBLookupCombo', 'TFWDBLookupCombo', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'Parameters', 'Params', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'fonctions_Objets_Dynamiques', 'fonctions_Objets_Data', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'fonctions_db,', 'fonctions_dbcomponents,', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TDBGrid', 'TExtDBGrid', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TExTExtDBGrid', 'TExtDBGrid', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TFWDBGrid', 'TExtDBGrid', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TExRxDBGrid', 'TExtDBGrid', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'p_CloseMDI', 'p_CloseForm', [rfReplaceAll,rfIgnoreCase] );


    ls_Lignes := StringReplace ( ls_Lignes, 'DataSourceKeyUnits', 'DataKeyUnit', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataSourceDisplay', 'DataFieldDisplay', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataSourceOwnerKey', 'DataKeyOwner', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataSourceOwnerTable,', 'DataTableOwner', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataSourceUnitTable', 'DataTableUnit', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataSourceGroupTable', 'DataTableGroup', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DatasourceFieldUnit', 'DataFieldUnit', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DatasourceFieldGroup', 'DataFieldGroup', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'fb_RefreshADODataset', 'fb_RefreshDataset', [rfReplaceAll,rfIgnoreCase] );


    ls_Lignes := StringReplace ( ls_Lignes, 'McFormDico', 'FormDico', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'McFormMainIni', 'FormMainIni', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TMCPageControl', 'TExtPageControl', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TExtPageControl', 'TPageControl', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'MCNumEdit', 'ExtNumEdit', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'MCColorCombo', 'ExtColorCombo', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'MCDBColorCombo', 'ExtDBColorCombo', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TDBColorComboBox', 'TExtDBColorCombo', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'RXDBCtrl', 'u_framework_dbcomponents', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'MCDBNumEdit', 'ExtDBNumEdit', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TAdvNavigateBtn', '', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'ADOAcces', 'Acces', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'ADOConnection', 'Connection', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TMCAdvGroupView', 'TDBGroupView', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TMCAdvListView', 'TDBListView', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TMCDBLookupComboEdit', 'TExtDBComboInsert', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TJvDBDateTimePicker', 'TFWDBDateEdit', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TJvMemo', 'TFWMemo', [rfReplaceAll,rfIgnoreCase] );



    ls_Lignes := StringReplace ( ls_Lignes, 'ValeurCleDatasource', 'DataKeyValue', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TExRxDBGrid', 'TFWDBGrid', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TLabel', 'TFWLabel', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'fb_SetFWLabels', 'fb_SetLabels', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TDBEdit', 'TFWDBEdit', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TRxDBLookupCombo', 'TFWDBLookupCombo', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TJvDBLookupCombo', 'TFWDBLookupCombo', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TDBAdvNavigator', 'TExtDBNavigator', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'nbFirst', 'nbEFirst', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'nbPost' , 'nbEPost', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'nbLast' , 'nbELast', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'nbPrior', 'nbEPrior', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'nbNext', 'nbENext', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'nbEdit', 'nbEEdit', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'nbInsert', 'nbEInsert', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'nbDelete', 'nbEDelete', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'nbCancel', 'nbECancel', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'nbRefresh', 'nbERefresh', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'nbSetBookmark', 'nbEMovePrior', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'nbGotoBookmark', 'nbEMoveNext', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'nbSearch', 'nbESearch', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TSvgFormInfoIni', 'TOnFormInfoIni', [rfReplaceAll,rfIgnoreCase] );

    // Conversion LAZARUS
    ls_Lignes := StringReplace ( ls_Lignes, 'TAdvListView', 'TJvListView', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TRbSplitter', 'TSplitter', [rfReplaceAll,rfIgnoreCase] );

    // Conversion ZEOS
    ls_Lignes := StringReplace ( ls_Lignes, 'TConnection', 'TADOConnection', [rfReplaceAll,rfIgnoreCase] );

    // Conversion Constantes
    ls_Lignes := StringReplace ( ls_Lignes, 'CST_ZONE_OBLIGATOIRE', 'GS_ZONE_OBLIGATOIRE', [rfReplaceAll,rfIgnoreCase] );

    //conversion couleurs
    ls_Lignes := StringReplace ( ls_Lignes, 'ColorEdit', 'gcol_Edit', [rfReplaceAll,rfIgnoreCase] );

    // Conversion LAZARUS
    // Renommage
    // Pas de RB
    ls_Lignes := StringReplace ( ls_Lignes, 'TRbPanel', 'TPanel', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TdxButtons', 'TJvXPButton', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TdxCheckBox', 'TJvXPCheckBox', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TdxXPBar', 'TJvXpBar', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataCancel', 'DataOnCancel', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataSave', 'DataOnSave', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataLoaded', 'DataOnLoaded', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBBeforeScroll', 'BeforeDataScroll', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBOnSearch', 'DataOnSearch', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBOnUnSearch', 'DataUnSearch', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBAfterScroll', 'AfterDataScroll', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBOnCanceled', 'OnDataCanceled', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBSearching', 'DataSearching', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBAfterSearch', 'OnEraseFilter', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBOnRecordError', 'OnDataRecordError', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBLocate', 'DataOnLocate', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBOnLocate', 'DataOnLocate', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBOnUsedKey', 'DataOnUsedKey', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBOnEmptyEdit', 'DataOnEmptyEdit', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBOnAllWhereBasket', 'OnDataAllWhereBasket', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'Data2Focus', 'Data2OnFocus', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataFocus', 'DataOnFocus', [rfReplaceAll,rfIgnoreCase] );

    // DBGRoupview

    ls_Lignes := StringReplace ( ls_Lignes, 'TMCDBGroupView', 'TDBGroupView', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'TMCDBListView', 'TDBListView', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataSourceOwnerKey', 'DataKeyOwner', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataSourceOwnerTable', 'DataTableOwner', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataSourceKeyUnits', 'DataFieldUnit', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataSourceDisplay', 'DataFieldsDisplay', [rfReplaceAll,rfIgnoreCase] );


    ls_Lignes := StringReplace ( ls_Lignes, 'DataKeyUnits', 'DataFieldUnit', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataSourceFieldUnit', 'DataFieldUnit', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataSourceFieldGroup', 'DataFieldGroup', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataSourceGroupTable', 'DataTableGroup', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataSourceUnitTable', 'DataTableUnit', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataOtherList', 'DataListOpposite', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBAllFilter', 'DataAllFilter', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBRecordValue', 'DataRecordValue', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBSensitiveBug', 'DataSensitiveBug', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DataBtn', 'Button', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBListPrimary', 'DataListPrimary', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'ColorValue', 'Value', [rfReplaceAll,rfIgnoreCase] );

    // FormDico
    ls_Lignes := StringReplace ( ls_Lignes, ', gt_gestionSouris2', '', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, ',gt_gestionSouris2', '', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, ', gt_gestionEdit2', '', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, ',gt_gestionEdit2', '', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, ', gt_gestionEdit', '', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, ', gt_gestionSouris', '', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, ',gt_gestionSouris', '', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, ',gt_gestionEdit', '', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'BeforeDicoCreate', 'BeforeCreate', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'DBSortDataset', 'DataOnSort', [rfReplaceAll,rfIgnoreCase] );

    ls_Lignes := StringReplace ( ls_Lignes, 'Cr?? par', 'Cr par', [rfReplaceAll,rfIgnoreCase] );
    ls_Lignes := StringReplace ( ls_Lignes, 'Modifi?', 'Modifi', [rfReplaceAll,rfIgnoreCase] );

    ls_Lignes := StringReplace ( ls_Lignes, 'DBSortDataset', 'DataOnSort', [rfReplaceAll,rfIgnoreCase] );

     if lb_DFM
     or lb_LFM Then
       ConvertitLigneDFM ( lst_Lignes, ls_Lignes )
      else
       ConvertitLignePAS ( lst_Lignes, ls_Lignes );

    Application.ProcessMessages;
  finally
    lst_Lignes.EndUpdate;
    lst_Lignes.SaveToFile   ( FilePath );
    lst_Lignes.Free;

  end;
    Messages.Lines.Add ( '  - Fichier ' + FileName + ' converti...' );
end;

procedure TForm1.ConvertitLignePAS( var ast_Lignes : TStringList ; as_Lignes : WideString );
var li_pos1 : Longint;
    ls_Ligne : WideString;
begin
 as_Lignes := StringReplace ( as_Lignes, 'fonctions_Objets_Dynamiques', 'fonctions_Objets_Data', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'fonctions_db,', 'fonctions_dbcomponents,', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'dxButtons,', 'JvXPButtons,', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'dxCheckBox,', 'JvXPCheckCtrls,', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'dxCore2,', '', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'dxCore,', '', [rfReplaceAll,rfIgnoreCase] );

 as_Lignes := StringReplace ( as_Lignes, 'u_exTExtDBGrid', 'U_ExtDBGrid', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'u_exTExtDBGrid', 'U_ExtDBGrid', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'ExRxDBGrid,', 'u_extdbgrid,', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'U_FormFrameWork', 'U_FormDico', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'U_MCColorComboBox', 'U_ColorCombos', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'DBAdvNavigator', 'U_ExtDBNavigator', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'SvgFormInfoIni,', 'U_OnFormInfoIni,', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'CST_MC_', 'CST_', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'U_MCAdvGroupView', 'U_GroupView', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'MCPageControl', 'U_ExtPageControl', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'mc_fonctions_', 'fonctions_', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'mc_fonction_', 'fonctions_', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'DBAdvNavigator', 'U_ExtDBNavigator', [rfReplaceAll,rfIgnoreCase] );
 as_Lignes := StringReplace ( as_Lignes, 'mc_constantes_messages', 'unite_messages', [rfReplaceAll,rfIgnoreCase] );

  // FOMR DICO
  as_Lignes := StringReplace ( as_Lignes, 'Data2NavEdit', 'Sources[1].NavEdit', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'ControlFocus3', 'Sources[2].ControlFocus', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data2LookupField', 'Sources[1].LookupField', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data2Key', 'Sources[1].Key', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data2Table', 'Sources[1].Table', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data2Panel', 'Sources[1].Panel', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data2Navigator', 'Sources[1].Navigator', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data3NavEdit', 'Sources[2].NavEdit', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'ControlFocus3', 'Sources[1].ControlFocus', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data3LookupField', 'Sources[2].LookupField', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data3Key', 'Sources[2].Key', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data3Table', 'Sources[2].Table', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data3Panel', 'Sources[2].Panel', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Data3Navigator', 'Sources[2].Navigator', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DataNavigator', 'Sources[0].Navigator', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DataNavEdit', 'Sources[0].NavEdit', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DataTable', 'Sources[0].Table', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DataKey', 'Sources[0].Key', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'ControlFocus', 'Sources[0].ControlFocus', [rfReplaceAll,rfIgnoreCase] );

  as_Lignes := StringReplace ( as_Lignes, 'Datasource2', 'Sources[1].Datasource', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Datasource3', 'Sources[2].Datasource', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, ' Datasource', ' Sources[0].Datasource', [rfReplaceAll,rfIgnoreCase] );

  as_Lignes := StringReplace ( as_Lignes, 'DataGridLookupField', 'Data3LookupField', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'DataGridOnScroll', 'Data2OnScroll', [rfReplaceAll,rfIgnoreCase] );
  as_Lignes := StringReplace ( as_Lignes, 'Sources[0].KeyUnit', 'DataKeyUnit', [rfReplaceAll,rfIgnoreCase] );

  // Indetation
  as_Lignes := StringReplace ( as_Lignes, chr(9), '  ', [rfReplaceAll] );
  ast_Lignes.Text := as_Lignes;
  li_pos1 := -1;
  ast_Lignes.EndUpdate;
  while li_pos1 < ast_Lignes.Count -1 do
    Begin
      Application.ProcessMessages;
      inc ( li_pos1 );
      ls_Ligne := ast_Lignes [ li_pos1 ];
      ConvertitLigneDFMPAS ( ls_Ligne );
      ast_Lignes [ li_pos1 ]:=ls_Ligne;

    End;
end;

procedure TForm1.ConvertitLigneDFMPAS( var as_Ligne : WideString );
var ls_ligne : String ;
begin

      ls_Ligne := lowercase ( as_ligne );
      if ( pos ( '_ferme', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWClose', [rfIgnoreCase] );

      if ( pos ( '_quit', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWQuit', [rfIgnoreCase] );

      if ( pos ( '_copie', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWCopy', [rfIgnoreCase] );

      if ( pos ( '_aperc', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWPreview', [rfIgnoreCase] );

      if ( pos ( 'bt_enr', ls_Ligne)> 0 )
      or ( pos ( 'bt_ok' , ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWOK', [rfIgnoreCase] );

      if ( pos ( '_init', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWInit', [rfIgnoreCase] );

      if ( pos ( '_insert', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWInsert', [rfIgnoreCase] );

      if ( pos ( 'in_total', ls_Ligne)> 0 )
      or ( pos ( 'intot', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWInAll', [rfIgnoreCase] );

      if ( pos ( 'out_total', ls_Ligne)> 0 )
      or ( pos ( 'outtot', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWOutAll', [rfIgnoreCase] );

      if ( pos ( 'bt_in', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWInSelect', [rfIgnoreCase] );

      if ( pos ( 'bt_out', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWOutSelect', [rfIgnoreCase] );

      if ( pos ( '_annul', ls_Ligne)> 0 )
      or ( pos ( '_aband', ls_Ligne)> 0 )
      or ( pos ( '_cancel', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWCancel', [rfIgnoreCase] );

      if ( pos ( '_imprim', ls_Ligne)> 0 )
      or ( pos ( '_print', ls_Ligne)> 0 ) then
        as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFWPrint', [rfIgnoreCase] );


end;
procedure TForm1.ConvertitPanelDFM( var asl_Lignes: TStringList; const ai_PosLigne : Longint; const as_Ligne, as_ReplaceString : String );
Begin
  asl_Lignes [ ai_PosLigne ] := StringReplace(as_Ligne,as_ReplaceString, 'Panel', [rfIgnoreCase,rfReplaceAll] );
  asl_Lignes.Insert(ai_PosLigne + 1,  '    end>');
  asl_Lignes.Insert(ai_PosLigne, '    Item');
  asl_Lignes.Insert(ai_PosLigne, '  Panels = <');
end;

procedure TForm1.ConvertitLigneDFM( var asl_Lignes: TStringList; as_Lignes : WideString );
var li_pos1, li_pos2, li_pos3, li_CountObject : LongInt;
    ls_Table : String;
    ls_Ligne, ls_Compare : WideString;
begin
  li_pos1:= 0;
  while ( PosEx ( 'TableName', as_Lignes, li_pos1 + 1 ) > li_pos1 ) do
    Begin
      li_pos1 := posEx ( 'TableName', as_Lignes, li_pos1 + 1 );
      li_pos2 := Posex ( '''', as_Lignes, li_pos1);
      li_pos3 := Posex ( '''', as_Lignes, li_pos2 +1);
      ls_Table := copy ( as_Lignes, li_pos2 + 1 , li_pos3 - 1 -li_pos2 );
//      Showmessage ( ls_Table+ ' '+inttoStr ( li_pos2 )+ ' '+inttoStr ( li_pos3 ));
      as_Lignes := copy ( as_Lignes, 1, li_pos2 - 1) + '(''SELECT * FROM ' + ls_Table + ''')' +  copy ( as_Lignes, li_pos3 + 1, length ( as_Lignes ) - li_pos3 );
    End;
  as_Lignes := StringReplace ( as_Lignes, 'TableName', 'SQL.Strings', [rfReplaceAll,rfIgnoreCase] );
  li_pos2 := -1;
  li_pos1 := -1;
  asl_Lignes.Text := as_Lignes ;
  asl_Lignes.EndUpdate;
  li_CountObject := 0;
  while li_pos1 < asl_Lignes.Count -1 do
    Begin
      Application.ProcessMessages;
      inc ( li_pos1 );
      ls_Ligne := asl_Lignes [ li_pos1 ];

      if pos ( 'object ', ls_Ligne ) > 0 Then
        Begin
         inc ( li_CountObject );
         if li_CountObject > 1 Then
           Break;
        End;

      ls_Compare := ls_ligne;



      ls_Ligne := StringReplace ( ls_Ligne, 'WorkDatasourceNavigator', 'NavEdit', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'WorkControlFocus', 'ControlFocus', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'DataWork4LookupField', 'LookupField', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'WorkDataKey', 'Key', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'WorkDatasourceKey', 'Key', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'WorkDataTable', 'Table', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'WorkDatasourceTable', 'Table', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'WorkDataNavigator', 'Navigator', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'WorkNavigator', 'Navigator', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'WorkDatasource', 'Datasource', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'WorkDBGrid', 'Grid', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'WorkDataGrid', 'Grid', [rfIgnoreCase] );

      ls_Ligne := StringReplace ( ls_Ligne, 'DataWork4Panel', 'PanelToReplace', [rfIgnoreCase] );

      if ( length ( ls_Ligne ) <> length ( ls_Compare ))
       then
        Begin
          ConvertitColumn ( asl_lignes,ls_ligne,li_pos1, li_pos2, li_pos3, 3 );
          Continue;
        End;


      ls_Ligne := StringReplace ( ls_Ligne, 'Datasource2NavEdit', 'NavEdit', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'DatasourceControlFocus3', 'ControlFocus', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'Datasource2LookupField', 'LookupField', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'Datasource2Key', 'Key', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'Datasource2Table', 'Table', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'Datasource2Panel', 'PanelToReplace', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'Datasource2Navigator', 'Navigator', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'Datasource2', 'Datasource', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'Datasource2Grid', 'Grid', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'ControlFocus2', 'ControlFocus', [rfIgnoreCase] );


      if ( length ( ls_Ligne ) <> length ( ls_Compare ))
       then
        Begin
          ConvertitColumn ( asl_lignes,ls_ligne, li_pos1, li_pos2, li_pos3, 1 );
        End;

      ls_Ligne := StringReplace ( ls_Ligne, 'GridLookupControlFocus', 'ControlFocus', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'DatasourceGridLookupField', 'LookupField', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'GridLookupKey', 'Key', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'GridLookup', 'Grid', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'GridLookupTable', 'Table', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'GridTable', 'Table', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'GridLookupPanel', 'PanelToReplace', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'GridLookupNavigator', 'Navigator', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'DBGridLookupDatasource', 'Datasource', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'GridDatasource', 'Datasource', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'GridLookupDatasource', 'Datasource', [rfIgnoreCase] );

      if  ( length ( ls_Ligne ) <> length ( ls_Compare ))
       then
        Begin
          ConvertitColumn ( asl_lignes,ls_ligne, li_pos1, li_pos2, li_pos3, 2 );
          Continue;
        End;

      ls_Ligne := StringReplace ( ls_Ligne, 'DBGridNavigator', 'Navigator', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'DBNavigatorEditor', 'NavEdit', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'DBGrid', 'Grid', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'DataSourceTable', 'Table', [rfIgnoreCase] );
      ls_Ligne := StringReplace ( ls_Ligne, 'DatasourceKey', 'Key', [rfIgnoreCase] );
      if ( pos ( '  Datasource', ls_Ligne) in [ 1..2] ) then
        ls_Ligne := StringReplace ( ls_Ligne, 'Datasource =', '    Datasource =', [rfIgnoreCase] );
      if ( pos ( '  ControlFocus', ls_Ligne) in [ 1..2] ) then
        ls_Ligne := StringReplace ( ls_Ligne, 'ControlFocus', '    ControlFocus', [rfIgnoreCase] );

      if ( length ( ls_Ligne ) <> length ( ls_Compare ))
       then
        Begin
          ConvertitColumn ( asl_lignes,ls_ligne, li_pos1, li_pos2, li_pos3, 0 );
          Continue;
        End;

      if ( pos ( 'groupview', ls_Ligne)> 0 ) then
        Break;
      asl_Lignes [ li_pos1 ] := ls_ligne;
    End;
    li_pos1 := -1;
    while li_pos1 < asl_Lignes.Count -1 do
      Begin
        Application.ProcessMessages;
        inc ( li_pos1 );
        ls_Ligne := asl_Lignes [ li_pos1 ];
        ls_Compare := ls_ligne;
        if pos( 'PanelToReplace', ls_ligne ) > 0 Then
          Begin
           ConvertitPanelDFM ( asl_Lignes, li_pos1, ls_Ligne, 'PanelToReplace');
           Continue;
          end;
      End;

  li_pos1 := -1;
  asl_Lignes.EndUpdate;
  while li_pos1 < asl_Lignes.Count -1 do
    Begin
      Application.ProcessMessages;
      inc ( li_pos1 );
      ls_Ligne := asl_Lignes [ li_pos1 ];
      ConvertitLigneDFMPAS ( ls_Ligne );
      asl_Lignes [ li_pos1 ]:=ls_Ligne;

    End;
end;
procedure TForm1.ConvertitColumn( var asl_Lignes: TStringList; const as_Ligne : WideString; var li_pos1,li_pos2, li_endcol : Longint ; const li_noData : Longint );
var li_Item, li_Counter, li_noItem : Longint;
    lb_Found : Boolean;
Begin
  if li_pos2 > 0 then
    Begin
      if ( li_pos1 < asl_lignes.count ) then
        asl_Lignes.Delete ( li_pos1 );
      if  ( li_noData = 0 ) Then
        Begin
          if ( li_pos2 + 2 < asl_lignes.count ) then
            Begin
              asl_Lignes.Insert ( li_pos2 + 2, as_Ligne ) ;
            End;
        End
      else
        Begin
          li_noItem := -1;
          lb_Found := False ;
          li_Item  := li_pos2;
          for li_Counter := li_pos2 to asl_Lignes.Count - 1 do
            Begin
              if pos ( '  end>', asl_Lignes [ li_counter ])>0 then
                Begin
                  li_Item  := li_counter;
                  Break;
                End;
              if pos ( ' Item', asl_Lignes [ li_counter ])>0 then
                Begin
                  inc(li_noItem);
                  if ( li_noitem = li_noData ) then
                    Begin
                      lb_Found := True ;
                      asl_Lignes.Insert( li_counter +1, as_Ligne );
                      Break;
                    End;

                End;
            End;
          if not lb_found then
            Begin
              asl_Lignes.Insert ( li_Item, as_Ligne );
              asl_Lignes.Insert ( li_Item, '    Item' );
              inc( li_endCol );
              if ( pos ( 'end', asl_lignes [ li_Item - 1 ])=0) then
                Begin
                  asl_Lignes.Insert ( li_Item, '    end' );
                  inc ( li_Item );
                  inc( li_endCol );
                End;

              if ( li_item < asl_lignes.count ) then
                for li_counter := li_noitem + 2  to li_noData do
                  Begin
                    asl_Lignes.Insert ( li_Item, '    end' );
                    asl_Lignes.Insert ( li_Item, '    Item' );
                    inc( li_endCol, 2 );
                  End;

            End;
        End;
    End
  else
    Begin
      li_pos2 := li_pos1 ;
      li_endCol :=li_pos2;
      asl_Lignes [ li_pos1 ] := as_Ligne;
      if ( li_pos2 < asl_lignes.count ) then
        Begin
          asl_Lignes.Insert ( li_pos2+1, '    end>' );
          asl_Lignes.Insert ( li_pos2, '    Item' );
          asl_Lignes.Insert ( li_pos2, '  Sources = <' );
          inc( li_endCol, 3 );
          for li_counter := 0 to li_noData -1 do
            Begin
              asl_Lignes.Insert ( li_pos2+1, '    end' );
              asl_Lignes.Insert ( li_pos2+1, '    Item' );
              inc( li_endCol, 2 );
            End;
        End;
    End ;
 li_pos1 := li_endcol;
end;

end.
