unit F_Convertir;

{$IFDEF FPC}
{$MODE Delphi}
{$R *.lfm}
{$ENDIF}

interface

uses
  SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FileCtrl, ExtCtrls, LResources, EditBtn;

type

  { TForm1 }

  TForm1 = class(TForm)
    ch_utf8: TCheckBox;
    DirectoryEdit: TDirectoryEdit;
    DirectoryListBox: TDirectoryEdit;
    Panel1: TPanel;
    FileListBox: TFileListBox;
    Convertir: TButton;
    FilterComboBox: TFilterComboBox;
    Messages: TMemo;
    Panel2: TPanel;
    procedure ConvertirClick(Sender: TObject);
    procedure DirectoryEdit1Change(Sender: TObject);
    procedure DirectoryEditChange(Sender: TObject);
    procedure FilterComboBoxChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OnFormInfoIniFormShow(Sender: TObject);
  private
    { Dclarations prives }
  public
    procedure ConvertitLignePAS( const ast_Lignes : TStringList; const ai_NoLigne : Integer ); virtual;
    procedure ConvertitFichier ( const FilePath, FileName  : String );
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

uses StrUtils,LConvEncoding,fonctions_string;


const as_ext : Array [ 0..19 ] of String = ( 'js', 'html', 'htm', 'css', 'jpeg', 'jpg', 'png', 'gif', 'pdf', 'doc', 'odt', 'docx', 'html?', 'js?', 'htm?', 'png?', 'gif?', 'png?', 'jpeg?', 'jpg?' ) ;

procedure TForm1.ConvertirClick(Sender: TObject);
var li_i : Integer ;
begin
  Messages.Lines.Clear;
  Messages.Lines.Add( '-> Parcourt de ' + DirectoryEdit.Directory );
  For Li_i := 0 To FileListBox.Items.Count - 1 do
    Begin
      ConvertitFichier ( DirectoryEdit.Directory + DirectorySeparator + FileListBox.Items.Strings [ li_i ], FileListBox.Items.Strings [ li_i ] );
    End ;
  Messages.Lines.Add ( '-> Fin pour ' + DirectoryEdit.Directory + '.' );
end;

procedure TForm1.DirectoryEdit1Change(Sender: TObject);
begin

end;

procedure TForm1.DirectoryEditChange(Sender: TObject);
begin
  FileListBox.Directory := DirectoryEdit.Directory ;
end;

procedure TForm1.FilterComboBoxChange(Sender: TObject);
begin
  FileListBox.Mask := FilterComboBox.Mask;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  if DirectoryEdit.Directory = '' Then
    DirectoryEdit.Directory:= GetCurrentDir;
end;

procedure TForm1.OnFormInfoIniFormShow(Sender: TObject);
begin
 FilterComboBoxChange ( Self );
end;

procedure TForm1.ConvertitFichier(const FilePath, FileName : String);
var lst_Lignes : TStringList ;

    afile : TextFile ;

    li_i : Integer;


begin
  lst_Lignes := TStringList.Create;
  try
    lst_Lignes.BeginUpdate;
    lst_Lignes.LoadFromFile ( FilePath );

    for li_i := 0 to lst_Lignes.count - 1 do
       ConvertitLignePAS (  lst_Lignes, li_i );

    Application.ProcessMessages;
  finally
    lst_Lignes.EndUpdate;
    lst_Lignes.SaveToFile   ( FilePath );
    lst_Lignes.Free;

  end;
    Messages.Lines.Add ( '  - Fichier ' + FileName + ' converti...' );
end;

procedure TForm1.ConvertitLignePAS( const ast_Lignes : TStringList ; const ai_noligne : Integer );
var li_pos1 : Longint;
    ls_Ligne : String;



    function fs_isnumeric ( as_chaine : String ; const ai_pos : Integer ): String;
    Begin
     li_pos1 := 0;
     while li_pos1 < ast_Lignes.Count -1 do
       Begin
         Application.ProcessMessages;
         inc ( li_pos1 );
         ls_Ligne := ast_Lignes [ li_pos1 ];
         ast_Lignes [ li_pos1 ]:=ls_Ligne;

       End;
    end;

    function fs_getextension ( const as_chaine : String ; const ai_pos : Integer ): String;
    var li_i, li_j, li_k : Integer;
        ls_ext : String;
    Begin
     li_pos1:= ai_pos;
     for li_i := 0 to 11 do
      Begin
        ls_ext:=as_ext[li_i];
       li_pos1 := posex ( '.'+ls_ext, as_chaine, li_pos1 );
        if li_pos1 > 0 Then
          Begin
           li_j := li_pos1+Length(ls_ext)+1;
           li_k := li_j;
           while (li_j < length ( as_chaine )) and IsNumber( as_chaine [li_j ] ) and ( as_chaine [li_j ] <> '''' ) and ( as_chaine [li_j ] <> '"' ) do
              Begin
                inc ( li_j );
              end;
           ast_Lignes [ ai_noligne ]:=copy(as_chaine,1,li_k)+copy(as_chaine,li_j, Length(as_chaine));
           fs_getextension(as_chaine,li_j);
          end;
        li_pos1 := posex ( '.'+ls_ext, as_chaine, li_pos1 );
        if li_pos1 > 0 Then
          Begin
           li_j := li_pos1-2;
           if IsNumber( as_chaine [ li_j ] )
           and (as_chaine [ li_j -1 ] = '-')
            then
             ast_Lignes [ ai_noligne ]:=copy(as_chaine,1,li_j-2)+copy(as_chaine,li_pos1, Length(as_chaine));
          end;
      end;


    end;
begin
 ls_Ligne:= ast_Lignes [ai_noligne];
 ls_Ligne := StringReplace ( ls_Ligne, 'plugins/auto/image_responsive/image_responsive.css', 'spip.css', [rfReplaceAll,rfIgnoreCase] );
 ls_Ligne := StringReplace ( ls_Ligne, 'plugins/auto/archive/css/perso_hyperspace.html', 'spip.css', [rfReplaceAll,rfIgnoreCase] );

 ls_Ligne := StringReplace ( ls_Ligne, '?page=barre_outils_icones.css', '', [rfReplaceAll,rfIgnoreCase] );

 ls_Ligne := StringReplace ( ls_Ligne, 'liberlog.fr', 'liberlog.org', [rfReplaceAll,rfIgnoreCase] );

 ls_Ligne := StringReplace ( ls_Ligne, '@liberlog.org', '  liberlog.fr', [rfReplaceAll,rfIgnoreCase] );

 ls_Ligne := StringReplace ( ls_Ligne, 'spipccbc.html?page=site ', 'http://www.livrels.fr', [rfReplaceAll,rfIgnoreCase] );

 ls_Ligne := StringReplace ( ls_Ligne, ' spip2ad6.html?page=rubrique&amp;id_rubrique=8"', 'http://www.devenir1genie.com" target="_blank', [rfReplaceAll,rfIgnoreCase] );

 ls_Ligne := StringReplace ( ls_Ligne, '="www.economie-reelle.org', '="http://www.economie-reelle.org" target="_blank', [rfReplaceAll,rfIgnoreCase] );

 ls_Ligne := StringReplace ( ls_Ligne, '="economie-reelle.org', '="http://www.economie-reelle.org" target="_blank', [rfReplaceAll,rfIgnoreCase] );

 ls_Ligne := StringReplace ( ls_Ligne, '"Contenus"', '"http://www.histoire.ovh" target="_blank', [rfReplaceAll,rfIgnoreCase] );

 ls_Ligne := StringReplace ( ls_Ligne, '7989.js??1560219744"', '.js"', [rfReplaceAll,rfIgnoreCase] );



 if (pos( '[if lte IE 8]', ls_Ligne ) > 0) and (pos ( 'ie', ls_Ligne ) > 0) Then
  ls_Ligne:='';

  if (pos( '.js', ls_Ligne ) > 0) and (pos ( 'jquery.', ls_Ligne ) > 0) and (pos ('text/javascript',ls_Ligne)>0) Then
   ls_Ligne:='';

  if (pos( '.js', ls_Ligne ) > 0) and (pos ( 'mediabox.', ls_Ligne ) > 0) and (pos ('text/javascript',ls_Ligne)>0) Then
   ls_Ligne:='';

  if (pos( '.js', ls_Ligne ) > 0) and (pos ( '/ajax', ls_Ligne ) > 0) and (pos ('text/javascript',ls_Ligne)>0) Then
   ls_Ligne:='';

  if (pos( '.js', ls_Ligne ) > 0) and (pos ( 'porte_plume', ls_Ligne ) > 0) and (pos ('text/javascript',ls_Ligne)>0) Then
   ls_Ligne:='';

  if (pos( '.js', ls_Ligne ) > 0) and (pos ( 'freepaper2', ls_Ligne ) > 0) and (pos ('text/javascript',ls_Ligne)>0) Then
   ls_Ligne:='';

  if (pos( '.js', ls_Ligne ) > 0) and (pos ( 'image_responsive', ls_Ligne ) > 0) and (pos ('text/javascript',ls_Ligne)>0) Then
   ls_Ligne:='';


  ls_Ligne:=StringReplace(ls_Ligne, '"""""""""','"', [rfReplaceAll,rfIgnoreCase] );
  ls_Ligne:=StringReplace(ls_Ligne, '''''''''','''', [rfReplaceAll,rfIgnoreCase] );
  ls_Ligne:=StringReplace(ls_Ligne, '''''''''','''', [rfReplaceAll,rfIgnoreCase] );
  ls_Ligne:=StringReplace(ls_Ligne, '''','''', [rfReplaceAll,rfIgnoreCase] );
  ls_Ligne:=StringReplace(ls_Ligne, '''><','><', [rfReplaceAll,rfIgnoreCase] ) ;



  ls_Ligne := StringReplace ( ls_Ligne, '"" type="', '" type="', [rfReplaceAll,rfIgnoreCase] );

  ls_Ligne := StringReplace ( ls_Ligne, '#section2_8', 'http://bitbucket.org/matthieugiroux', [rfReplaceAll,rfIgnoreCase] );
  ls_Ligne := StringReplace ( ls_Ligne, '#section13', 'http://liberlog.org', [rfReplaceAll,rfIgnoreCase] );
  ls_Ligne := StringReplace ( ls_Ligne, '#section51', 'Contact.html', [rfReplaceAll,rfIgnoreCase] );
  ls_Ligne := StringReplace ( ls_Ligne, '#section39', 'Enfants.html', [rfReplaceAll,rfIgnoreCase] );
  ls_Ligne := StringReplace ( ls_Ligne, '#section37', 'Migrer-avec-ou-vers-un-outil-RAD.html', [rfReplaceAll,rfIgnoreCase] );
  ls_Ligne := StringReplace ( ls_Ligne, '#section7', 'http://dtra.fr', [rfReplaceAll,rfIgnoreCase] );
  ls_Ligne := StringReplace ( ls_Ligne, '#section1', 'http://www.informalibre.com/', [rfReplaceAll,rfIgnoreCase] );
  ls_Ligne := StringReplace ( ls_Ligne, '#section8', 'http://histoire.ovh', [rfReplaceAll,rfIgnoreCase] );
  ls_Ligne := StringReplace ( ls_Ligne, '#section3', 'http://virtualpascal.com', [rfReplaceAll,rfIgnoreCase] );
  ls_Ligne := StringReplace ( ls_Ligne, '#section6', 'Web.html', [rfReplaceAll,rfIgnoreCase] );




 ls_Ligne := StringReplace ( ls_Ligne, '="Web.html', '="http://www.informalibre.com" "target="_blank', [rfReplaceAll,rfIgnoreCase ]);
 ls_Ligne := StringReplace ( ls_Ligne, 'http://informalibre.com target', 'http://informalibre.com" "target', [rfReplaceAll,rfIgnoreCase] );

 ls_Ligne := StringReplace ( ls_Ligne, 'spip2ad6.html?page=rubrique&id_rubrique=8 ', '="https://bitbucket.org/matthieugiroux" target="_blank', [rfReplaceAll,rfIgnoreCase ]);
 ls_Ligne := StringReplace ( ls_Ligne, 'spipccbc.html?page=site', 'Sites-Web.html', [rfReplaceAll,rfIgnoreCase ]);
 ls_Ligne := StringReplace ( ls_Ligne, 'spip2ad6.html?page=rubrique&amp;id_rubrique=8', 'Composants.html', [rfReplaceAll,rfIgnoreCase ]);
 ls_Ligne := StringReplace ( ls_Ligne, 'Libre-1-1-1-1-1-1-1.html', 'http://livrels.org', [rfReplaceAll,rfIgnoreCase ]);
 ls_Ligne := StringReplace ( ls_Ligne, 'Logiciel-3.html', 'http://virtualpascal.com', [rfReplaceAll,rfIgnoreCase ]);
 ls_Ligne := StringReplace ( ls_Ligne, 'XML-Frames-engine.html', 'http://xmlframes.com', [rfReplaceAll,rfIgnoreCase ]);
 ls_Ligne := StringReplace ( ls_Ligne, 'Extended-Components.html', 'http://extended.in', [rfReplaceAll,rfIgnoreCase ]);
 ls_Ligne := StringReplace ( ls_Ligne, 'Composants-Extended.html', 'http://manframes.fr', [rfReplaceAll,rfIgnoreCase ]);
 ls_Ligne := StringReplace ( ls_Ligne, 'Moteur-XML-Frames.html', 'http://xmlframes.fr', [rfReplaceAll,rfIgnoreCase ]);
 ls_Ligne := StringReplace ( ls_Ligne, 'Moteur-Man-Frames.html', 'http://manframes.fr', [rfReplaceAll,rfIgnoreCase ]);
 ls_Ligne := StringReplace ( ls_Ligne, 'Family-trees.html', 'http://ancestromania.net/indexb599.html', [rfReplaceAll,rfIgnoreCase ]);





 ls_Ligne := StringReplace ( ls_Ligne, 'index.php', 'index.html', [rfReplaceAll,rfIgnoreCase] );

 ast_Lignes [ai_noligne] := ls_Ligne;

 fs_getextension ( ls_Ligne, 1 );


end;


end.
